package cz.muni.fi.pa165.icehockeymanager.rest.demo;

import cz.muni.fi.pa165.icehockeymanager.dto.TeamCreateDto;
import cz.muni.fi.pa165.icehockeymanager.facades.LeagueManagerFacade;
import cz.muni.fi.pa165.icehockeymanager.facades.UserAuthFacade;
import cz.muni.fi.pa165.icehockeymanager.facades.UserFacade;
import org.springframework.boot.ApplicationArguments;
import org.springframework.boot.ApplicationRunner;
import org.springframework.stereotype.Component;

@Component
public class DataLoader implements ApplicationRunner {

    private final UserAuthFacade userAuth;
    private final LeagueManagerFacade leagueManager;
    private final UserFacade userFacade;

    public DataLoader(UserAuthFacade userAuth, LeagueManagerFacade leagueManager, UserFacade userFacade) {
        this.userAuth = userAuth;
        this.leagueManager = leagueManager;
        this.userFacade = userFacade;
    }

    private static TeamCreateDto createTeam(String name) {
        var team = new TeamCreateDto();
        team.setName(name);
        return team;
    }

    @Override
    public void run(ApplicationArguments args) throws Exception {
        leagueManager.createNewTeam(createTeam("Toronto Maple Leafs"));
        var teams = userFacade.getTeamsInLeague();
        var team = teams.stream().findFirst().orElseThrow();
        userAuth.createTeamManager("team_manager", "1234", team.getId().intValue());
    }
}
